﻿Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Text
Imports System.Windows.Forms

Public Class CalibrationForm
    Inherits Form

    Private bCalibration As Bitmap
    Private gCalibration As Graphics

    Private screenWidth As Integer = 1024
    'defaults
    Private screenHeight As Integer = 768

    Public Sub New()
        Dim rect As New Rectangle()
        rect = Screen.GetWorkingArea(Me)

        InitializeComponent()
        Me.FormBorderStyle = FormBorderStyle.None
        Me.Left = 0
        Me.Top = 0
        Me.Size = New Size(rect.Width, rect.Height)
        Me.Text = "Calibration - Working area:" & Screen.GetWorkingArea(Me).ToString() & " || Real area: " & Screen.GetBounds(Me).ToString()

        AddHandler Me.KeyDown, New System.Windows.Forms.KeyEventHandler(AddressOf Me.OnKeyPress)


        screenHeight = rect.Height
        screenWidth = rect.Width

        bCalibration = New Bitmap(screenWidth, screenHeight, PixelFormat.Format24bppRgb)
        gCalibration = Graphics.FromImage(bCalibration)
        pbCalibrate.Left = 0
        pbCalibrate.Top = 0
        pbCalibrate.Size = New Size(rect.Width, rect.Height)

        gCalibration.Clear(Color.White)

        BeginInvoke(DirectCast(Sub() pbCalibrate.Image = bCalibration, MethodInvoker))
    End Sub

    Private Overloads Sub OnKeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        If CInt(CByte(e.KeyCode)) = CInt(Keys.Escape) Then
            Me.Dispose()
            Form1.WindowState = FormWindowState.Normal
            ' Esc was pressed
            Return
        End If
    End Sub

    Public Sub drawCrosshair(ByVal x As Integer, ByVal y As Integer, ByVal size As Integer, ByVal p As Pen, ByVal g As Graphics)
        g.DrawEllipse(p, x - size \ 2, y - size \ 2, size, size)
        g.DrawLine(p, x - size, y, x + size, y)
        g.DrawLine(p, x, y - size, x, y + size)
    End Sub

    Public Sub showCalibration(ByVal x As Integer, ByVal y As Integer, ByVal size As Integer, ByVal p As Pen)
        gCalibration.Clear(Color.White)
        drawCrosshair(x, y, size, p, gCalibration)
        BeginInvoke(DirectCast(Sub() pbCalibrate.Image = bCalibration, MethodInvoker))

    End Sub
End Class