﻿Public Class Draw_Settings

    Private Sub CBPenWidth_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CBPenWidth.SelectedIndexChanged
        Drawer.NewPen = New Pen(newcol, CSng(CBPenWidth.SelectedItem))
    End Sub

    Private Sub CBBGColor_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CBPBBGColor.SelectedIndexChanged
        If MsgBox("Wenn Sie die Hintergrundfarbe ändern, werden alle Zeichnungen gelöscht. Fortfahren?", MsgBoxStyle.YesNo + MsgBoxStyle.Question, "Verwerfen?") = MsgBoxResult.Yes Then
            Using gr As Graphics = Graphics.FromImage(Drawer.HG_Bmp)
                gr.Clear(Color.FromName(CBPBBGColor.SelectedItem))
                gr.DrawImage(Drawer.bmp, 0, 0)
                Drawer.PBDraw.Invalidate()
            End Using
        End If
    End Sub

    Dim newcol As Color

    Private Sub CBPenColor_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CBPenColor.SelectedIndexChanged
        If CBPenColor.SelectedIndex = 0 Then
            newcol = Color.Black
        ElseIf CBPenColor.SelectedIndex = 1 Then
            newcol = Color.Red
        ElseIf CBPenColor.SelectedIndex = 2 Then
            newcol = Color.Blue
        ElseIf CBPenColor.SelectedIndex = 3 Then
            newcol = Color.Green
        ElseIf CBPenColor.SelectedIndex = 4 Then
            newcol = Color.Yellow
        ElseIf CBPenColor.SelectedIndex = 5 Then
            newcol = Color.Gray
        ElseIf CBPenColor.SelectedIndex = 6 Then
            newcol = Color.White
        ElseIf CBPenColor.SelectedIndex = 7 Then
            If ColorDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
                newcol = ColorDialog1.Color
            Else
                Exit Sub
            End If
        End If

        TSL_ColPrev.BackColor = newcol
        Drawer.NewPen = New Pen(newcol, CSng(CBPenWidth.SelectedItem))
    End Sub

    Private Sub Draw_Settings_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each c As String In GetColors()
            'CBPenColor.Items.Add(c)
            CBPBBGColor.Items.Add(c)
        Next
        For a As Integer = 1 To 50
            CBPenWidth.Items.Add(a.ToString)
        Next
        CBPenColor.SelectedItem = CBPenColor.Items(0)
        CBPenWidth.SelectedItem = CBPenWidth.Items(0)
    End Sub

    Private Function GetColors() As List(Of String)
        Dim colors As New List(Of String)()
        Dim colorNames As String() = [Enum].GetNames(GetType(KnownColor))
        For Each colorName As String In colorNames
            Dim knownColor As KnownColor = DirectCast([Enum].Parse(GetType(KnownColor), colorName), KnownColor)
            If knownColor > knownColor.Transparent Then
                colors.Add(colorName)
            End If
        Next
        Return colors
    End Function

    Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSB_Exit.Click
        Form1.Show()

        Me.Close()
        Drawer.Close()
    End Sub

    Private Sub TSB_Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSB_Save.Click
        SaveFileDialog1.FileName = My.Computer.Clock.LocalTime.Day.ToString & "." & My.Computer.Clock.LocalTime.Month.ToString & "." & My.Computer.Clock.LocalTime.Year.ToString & "__" & My.Computer.Clock.LocalTime.Hour.ToString & "_" & My.Computer.Clock.LocalTime.Minute.ToString & "_" & My.Computer.Clock.LocalTime.Second.ToString

        If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Drawer.PBDraw.Image.Save(SaveFileDialog1.FileName)
        End If
    End Sub

    Private Sub TSB_Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSB_Open.Click
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim img As Image = Image.FromFile(OpenFileDialog1.FileName)

            Drawer.Show()

            Drawer.HG_Bmp = img 'New Bitmap(img.Width, img.Height)
            Drawer.bmp = img 'New Bitmap(img.Width, img.Height)

            Drawer.PBDraw.Image = Drawer.HG_Bmp
        End If
    End Sub
End Class