'''///////////////////////////////////////////////////////////////////////////////
'	Events.cs
'	Managed Wiimote Library
'	Written by Brian Peek (http://www.brianpeek.com/)
'	for MSDN's Coding4Fun (http://msdn.microsoft.com/coding4fun/)
'	Visit http://blogs.msdn.com/coding4fun/archive/2007/03/14/1879033.aspx
'	for more information
'''///////////////////////////////////////////////////////////////////////////////


Namespace WiimoteLib
	''' <summary>
	''' Event to handle a state change on the Wiimote
	''' </summary>
	''' <param name="sender">Object sending the event</param>
	''' <param name="args">Current Wiimote state</param>
	Public Delegate Sub WiimoteChangedEventHandler(sender As Object, args As WiimoteChangedEventArgs)

	''' <summary>
	''' Event to handle insertion/removal of an extension (Nunchuk/Classic Controller)
	''' </summary>
	''' <param name="sender">Object sending the event</param>
	''' <param name="args">Current extension status</param>
	Public Delegate Sub WiimoteExtensionChangedEventHandler(sender As Object, args As WiimoteExtensionChangedEventArgs)

	''' <summary>
	''' Argument sent through the WiimoteExtensionChangedEvent
	''' </summary>
	Public Class WiimoteExtensionChangedEventArgs
		Inherits EventArgs
		''' <summary>
		''' The extenstion type inserted or removed
		''' </summary>
		Public ExtensionType As ExtensionType
		''' <summary>
		''' Whether the extension was inserted or removed
		''' </summary>
		Public Inserted As Boolean

		''' <summary>
		''' Constructor
		''' </summary>
		''' <param name="type">The extension type inserted or removed</param>
		''' <param name="inserted">Whether the extension was inserted or removed</param>
		Public Sub New(type As ExtensionType, inserted__1 As Boolean)
			ExtensionType = type
			Inserted = inserted__1
		End Sub
	End Class

	''' <summary>
	''' Argument sent through the WiimoteChangedEvent
	''' </summary>
	Public Class WiimoteChangedEventArgs
		Inherits EventArgs
		''' <summary>
		''' The current state of the Wiimote and extension controllers
		''' </summary>
		Public WiimoteState As WiimoteState

		''' <summary>
		''' Constructor
		''' </summary>
		''' <param name="ws">Wiimote state</param>
		Public Sub New(ws As WiimoteState)
			WiimoteState = ws
		End Sub
	End Class
End Namespace
